#light

open System

// ------------------------------------------------------------------
// Represents expression
type simple_expr =
  | Int of int
  | Add of simple_expr * simple_expr
  | Sub of simple_expr * simple_expr
  | Mul of simple_expr * simple_expr
  | Div of simple_expr * simple_expr

// ------------------------------------------------------------------
// Evaluates expression value
let rec eval e =
  match e with
    | Int i -> i
    | Add (x,y) -> eval x + eval y
    | Sub (x,y) -> eval x - eval y
    | Mul (x,y) -> eval x * eval y
    | Div (x,y) -> eval x / eval y
  
// ------------------------------------------------------------------
// Converts expression to string
let rec tostring e = 
  match e with
    | Int n -> n.ToString()
    | Add (x,y) -> "("^(tostring x)^" + "^(tostring y)^")"
    | Sub (x,y) -> "("^(tostring x)^" - "^(tostring y)^")"
    | Mul (x,y) -> "("^(tostring x)^" * "^(tostring y)^")"
    | Div (x,y) -> "("^(tostring x)^" / "^(tostring y)^")"
    
// ------------------------------------------------------------------

// Expression: 5 + 3 * 2
let e = Add (Int 5, Mul (Int 3, Int 2))

// Calling functions:
tostring e
eval e